// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  crystal growth group                                                  ==
// ==                                                                        ==
// ==  Stiftung caesar                                                       ==
// ==  Ludwig-Erhard-Allee 2                                                 ==
// ==  53175 Bonn                                                            ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  http://www.caesar.de/cg/AMDiS                                         ==
// ==                                                                        ==
// ============================================================================

/** \file Newton.h */

#ifndef AMDIS_newTON_H
#define AMDIS_newTON_H

#if 0

#include "CreatorInterface.h"
#include "NonLinSolver.h"
#include "AMDiS_fwd.h"

namespace AMDiS {

  /**
   * \ingroup Solver
   * 
   * \brief
   * Implements the newton method for solving a non linear system. Sub class of
   * NonLinSolver.
   */
  template<typename VectorType>
  class Newton : public NonLinSolver<VectorType>
  {
  public:
    /// Creator class used in the NonLinSolverMap.
    class Creator : public NonLinSolverCreator<VectorType> 
    {
    public:
      virtual ~Creator() {}

      /// Returns a new Newton object.
      NonLinSolver<VectorType>* create() 
      { 
	return new Newton(this->name, this->linearSolver, this->nonLinUpdater); 
      }
    };

    /// Calls constructor of base class NonLinSolver
    Newton(std::string name_, 
	   OEMSolver *linSolver_,
	   NonLinUpdater<VectorType> *updater)
      : NonLinSolver<VectorType>(name_, linSolver_, updater)
    {}

  private:
    /// realisation of NonLinSolver::init
    void init();

    /// realisation of NonLinSolver::nlsolve
    int nlsolve(MatVecMultiplier<VectorType> *matVec,
		VectorType *x, VectorType *rhs,
		Preconditioner<VectorType> *lPrecon = NULL,
		Preconditioner<VectorType> *rPrecon = NULL);

    /// realisation of NonLinSolver::exit
    void exit();

  private:
    /// internal used data
    VectorType *b;
  };

}

#include "Newton.hh"

#endif

#endif // AMDIS_newTON_H
